/*
 * 
 */
package net.officefloor.model.objects;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class AutoWireManagedObjectModel extends AbstractModel implements ItemModel<AutoWireManagedObjectModel>, AutoWireObjectSourceModel {

    public static enum AutoWireManagedObjectEvent {
     CHANGE_MANAGED_OBJECT_SOURCE_CLASS_NAME, CHANGE_TIMEOUT, CHANGE_QUALIFIER, CHANGE_TYPE, ADD_PROPERTY_SOURCE, REMOVE_PROPERTY_SOURCE, ADD_AUTO_WIRE, REMOVE_AUTO_WIRE, ADD_FLOW, REMOVE_FLOW, ADD_TEAM, REMOVE_TEAM, ADD_DEPENDENCY, REMOVE_DEPENDENCY
    }

    /**
     * Default constructor.
     */
    public AutoWireManagedObjectModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public AutoWireManagedObjectModel(
      String managedObjectSourceClassName
    , long timeout
    , String qualifier
    , String type
    ) {
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.timeout = timeout;
        this.qualifier = qualifier;
        this.type = type;
    }

    /**
     * Convenience constructor.
     */
    public AutoWireManagedObjectModel(
      String managedObjectSourceClassName
    , long timeout
    , String qualifier
    , String type
    , PropertySourceModel[] propertySource
    , AutoWireModel[] autoWire
    , AutoWireFlowModel[] flow
    , AutoWireTeamModel[] team
    , AutoWireDependencyModel[] dependency
    ) {
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.timeout = timeout;
        this.qualifier = qualifier;
        this.type = type;
        if (propertySource != null) {
            for (PropertySourceModel model : propertySource) {
                this.propertySource.add(model);
            }
        }
        if (autoWire != null) {
            for (AutoWireModel model : autoWire) {
                this.autoWire.add(model);
            }
        }
        if (flow != null) {
            for (AutoWireFlowModel model : flow) {
                this.flow.add(model);
            }
        }
        if (team != null) {
            for (AutoWireTeamModel model : team) {
                this.team.add(model);
            }
        }
        if (dependency != null) {
            for (AutoWireDependencyModel model : dependency) {
                this.dependency.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public AutoWireManagedObjectModel(
      String managedObjectSourceClassName
    , long timeout
    , String qualifier
    , String type
    , PropertySourceModel[] propertySource
    , AutoWireModel[] autoWire
    , AutoWireFlowModel[] flow
    , AutoWireTeamModel[] team
    , AutoWireDependencyModel[] dependency
    , int x
    , int y
    ) {
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.timeout = timeout;
        this.qualifier = qualifier;
        this.type = type;
        if (propertySource != null) {
            for (PropertySourceModel model : propertySource) {
                this.propertySource.add(model);
            }
        }
        if (autoWire != null) {
            for (AutoWireModel model : autoWire) {
                this.autoWire.add(model);
            }
        }
        if (flow != null) {
            for (AutoWireFlowModel model : flow) {
                this.flow.add(model);
            }
        }
        if (team != null) {
            for (AutoWireTeamModel model : team) {
                this.team.add(model);
            }
        }
        if (dependency != null) {
            for (AutoWireDependencyModel model : dependency) {
                this.dependency.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Managed object source class name.
     */
    private String managedObjectSourceClassName;

    public String getManagedObjectSourceClassName() {
        return this.managedObjectSourceClassName;
    }

    public void setManagedObjectSourceClassName(String managedObjectSourceClassName) {
        String oldValue = this.managedObjectSourceClassName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.changeField(oldValue, this.managedObjectSourceClassName, AutoWireManagedObjectEvent.CHANGE_MANAGED_OBJECT_SOURCE_CLASS_NAME);
    }

    /**
     * Timeout.
     */
    private long timeout;

    public long getTimeout() {
        return this.timeout;
    }

    public void setTimeout(long timeout) {
        long oldValue = this.timeout;
        this.timeout = timeout;
        this.changeField(oldValue, this.timeout, AutoWireManagedObjectEvent.CHANGE_TIMEOUT);
    }

    /**
     * Qualifier.
     */
    private String qualifier;

    public String getQualifier() {
        return this.qualifier;
    }

    public void setQualifier(String qualifier) {
        String oldValue = this.qualifier;
        this.qualifier = qualifier;
        this.changeField(oldValue, this.qualifier, AutoWireManagedObjectEvent.CHANGE_QUALIFIER);
    }

    /**
     * Type.
     */
    private String type;

    public String getType() {
        return this.type;
    }

    public void setType(String type) {
        String oldValue = this.type;
        this.type = type;
        this.changeField(oldValue, this.type, AutoWireManagedObjectEvent.CHANGE_TYPE);
    }


    /**
     * Property source.
     */
    private List<PropertySourceModel> propertySource = new LinkedList<PropertySourceModel>();

    public List<PropertySourceModel> getPropertySources() {
        return this.propertySource;
    }

    public void addPropertySource(PropertySourceModel propertySource) {
        this.addItemToList(propertySource, this.propertySource, AutoWireManagedObjectEvent.ADD_PROPERTY_SOURCE);
    }

    public void removePropertySource(PropertySourceModel propertySource) {
        this.removeItemFromList(propertySource, this.propertySource, AutoWireManagedObjectEvent.REMOVE_PROPERTY_SOURCE);
    }

    /**
     * Auto wire.
     */
    private List<AutoWireModel> autoWire = new LinkedList<AutoWireModel>();

    public List<AutoWireModel> getAutoWiring() {
        return this.autoWire;
    }

    public void addAutoWire(AutoWireModel autoWire) {
        this.addItemToList(autoWire, this.autoWire, AutoWireManagedObjectEvent.ADD_AUTO_WIRE);
    }

    public void removeAutoWire(AutoWireModel autoWire) {
        this.removeItemFromList(autoWire, this.autoWire, AutoWireManagedObjectEvent.REMOVE_AUTO_WIRE);
    }

    /**
     * Flow.
     */
    private List<AutoWireFlowModel> flow = new LinkedList<AutoWireFlowModel>();

    public List<AutoWireFlowModel> getFlows() {
        return this.flow;
    }

    public void addFlow(AutoWireFlowModel flow) {
        this.addItemToList(flow, this.flow, AutoWireManagedObjectEvent.ADD_FLOW);
    }

    public void removeFlow(AutoWireFlowModel flow) {
        this.removeItemFromList(flow, this.flow, AutoWireManagedObjectEvent.REMOVE_FLOW);
    }

    /**
     * Team.
     */
    private List<AutoWireTeamModel> team = new LinkedList<AutoWireTeamModel>();

    public List<AutoWireTeamModel> getTeams() {
        return this.team;
    }

    public void addTeam(AutoWireTeamModel team) {
        this.addItemToList(team, this.team, AutoWireManagedObjectEvent.ADD_TEAM);
    }

    public void removeTeam(AutoWireTeamModel team) {
        this.removeItemFromList(team, this.team, AutoWireManagedObjectEvent.REMOVE_TEAM);
    }

    /**
     * Dependency.
     */
    private List<AutoWireDependencyModel> dependency = new LinkedList<AutoWireDependencyModel>();

    public List<AutoWireDependencyModel> getDependencies() {
        return this.dependency;
    }

    public void addDependency(AutoWireDependencyModel dependency) {
        this.addItemToList(dependency, this.dependency, AutoWireManagedObjectEvent.ADD_DEPENDENCY);
    }

    public void removeDependency(AutoWireDependencyModel dependency) {
        this.removeItemFromList(dependency, this.dependency, AutoWireManagedObjectEvent.REMOVE_DEPENDENCY);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<AutoWireManagedObjectModel> removeConnections() {
        RemoveConnectionsAction<AutoWireManagedObjectModel> _action = new RemoveConnectionsAction<AutoWireManagedObjectModel>(this);
        return _action;
    }
}
