/*
 * 
 */
package net.officefloor.model.objects;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class AutoWireSupplierModel extends AbstractModel implements ItemModel<AutoWireSupplierModel>, AutoWireObjectSourceModel {

    public static enum AutoWireSupplierEvent {
     CHANGE_SUPPLIER_SOURCE_CLASS_NAME, ADD_PROPERTY_SOURCE, REMOVE_PROPERTY_SOURCE
    }

    /**
     * Default constructor.
     */
    public AutoWireSupplierModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public AutoWireSupplierModel(
      String supplierSourceClassName
    ) {
        this.supplierSourceClassName = supplierSourceClassName;
    }

    /**
     * Convenience constructor.
     */
    public AutoWireSupplierModel(
      String supplierSourceClassName
    , PropertySourceModel[] propertySource
    ) {
        this.supplierSourceClassName = supplierSourceClassName;
        if (propertySource != null) {
            for (PropertySourceModel model : propertySource) {
                this.propertySource.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public AutoWireSupplierModel(
      String supplierSourceClassName
    , PropertySourceModel[] propertySource
    , int x
    , int y
    ) {
        this.supplierSourceClassName = supplierSourceClassName;
        if (propertySource != null) {
            for (PropertySourceModel model : propertySource) {
                this.propertySource.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Supplier source class name.
     */
    private String supplierSourceClassName;

    public String getSupplierSourceClassName() {
        return this.supplierSourceClassName;
    }

    public void setSupplierSourceClassName(String supplierSourceClassName) {
        String oldValue = this.supplierSourceClassName;
        this.supplierSourceClassName = supplierSourceClassName;
        this.changeField(oldValue, this.supplierSourceClassName, AutoWireSupplierEvent.CHANGE_SUPPLIER_SOURCE_CLASS_NAME);
    }


    /**
     * Property source.
     */
    private List<PropertySourceModel> propertySource = new LinkedList<PropertySourceModel>();

    public List<PropertySourceModel> getPropertySources() {
        return this.propertySource;
    }

    public void addPropertySource(PropertySourceModel propertySource) {
        this.addItemToList(propertySource, this.propertySource, AutoWireSupplierEvent.ADD_PROPERTY_SOURCE);
    }

    public void removePropertySource(PropertySourceModel propertySource) {
        this.removeItemFromList(propertySource, this.propertySource, AutoWireSupplierEvent.REMOVE_PROPERTY_SOURCE);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<AutoWireSupplierModel> removeConnections() {
        RemoveConnectionsAction<AutoWireSupplierModel> _action = new RemoveConnectionsAction<AutoWireSupplierModel>(this);
        return _action;
    }
}
