/*
 * 
 */
package net.officefloor.model.teams;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class AutoWireTeamModel extends AbstractModel implements ItemModel<AutoWireTeamModel> {

    public static enum AutoWireTeamEvent {
     CHANGE_TEAM_SOURCE_CLASS_NAME, CHANGE_QUALIFIER, CHANGE_TYPE, ADD_PROPERTY_SOURCE, REMOVE_PROPERTY_SOURCE, ADD_AUTO_WIRE, REMOVE_AUTO_WIRE
    }

    /**
     * Default constructor.
     */
    public AutoWireTeamModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public AutoWireTeamModel(
      String teamSourceClassName
    , String qualifier
    , String type
    ) {
        this.teamSourceClassName = teamSourceClassName;
        this.qualifier = qualifier;
        this.type = type;
    }

    /**
     * Convenience constructor.
     */
    public AutoWireTeamModel(
      String teamSourceClassName
    , String qualifier
    , String type
    , PropertySourceModel[] propertySource
    , AutoWireModel[] autoWire
    ) {
        this.teamSourceClassName = teamSourceClassName;
        this.qualifier = qualifier;
        this.type = type;
        if (propertySource != null) {
            for (PropertySourceModel model : propertySource) {
                this.propertySource.add(model);
            }
        }
        if (autoWire != null) {
            for (AutoWireModel model : autoWire) {
                this.autoWire.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public AutoWireTeamModel(
      String teamSourceClassName
    , String qualifier
    , String type
    , PropertySourceModel[] propertySource
    , AutoWireModel[] autoWire
    , int x
    , int y
    ) {
        this.teamSourceClassName = teamSourceClassName;
        this.qualifier = qualifier;
        this.type = type;
        if (propertySource != null) {
            for (PropertySourceModel model : propertySource) {
                this.propertySource.add(model);
            }
        }
        if (autoWire != null) {
            for (AutoWireModel model : autoWire) {
                this.autoWire.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Team source class name.
     */
    private String teamSourceClassName;

    public String getTeamSourceClassName() {
        return this.teamSourceClassName;
    }

    public void setTeamSourceClassName(String teamSourceClassName) {
        String oldValue = this.teamSourceClassName;
        this.teamSourceClassName = teamSourceClassName;
        this.changeField(oldValue, this.teamSourceClassName, AutoWireTeamEvent.CHANGE_TEAM_SOURCE_CLASS_NAME);
    }

    /**
     * Qualifier.
     */
    private String qualifier;

    public String getQualifier() {
        return this.qualifier;
    }

    public void setQualifier(String qualifier) {
        String oldValue = this.qualifier;
        this.qualifier = qualifier;
        this.changeField(oldValue, this.qualifier, AutoWireTeamEvent.CHANGE_QUALIFIER);
    }

    /**
     * Type.
     */
    private String type;

    public String getType() {
        return this.type;
    }

    public void setType(String type) {
        String oldValue = this.type;
        this.type = type;
        this.changeField(oldValue, this.type, AutoWireTeamEvent.CHANGE_TYPE);
    }


    /**
     * Property source.
     */
    private List<PropertySourceModel> propertySource = new LinkedList<PropertySourceModel>();

    public List<PropertySourceModel> getPropertySources() {
        return this.propertySource;
    }

    public void addPropertySource(PropertySourceModel propertySource) {
        this.addItemToList(propertySource, this.propertySource, AutoWireTeamEvent.ADD_PROPERTY_SOURCE);
    }

    public void removePropertySource(PropertySourceModel propertySource) {
        this.removeItemFromList(propertySource, this.propertySource, AutoWireTeamEvent.REMOVE_PROPERTY_SOURCE);
    }

    /**
     * Auto wire.
     */
    private List<AutoWireModel> autoWire = new LinkedList<AutoWireModel>();

    public List<AutoWireModel> getAutoWiring() {
        return this.autoWire;
    }

    public void addAutoWire(AutoWireModel autoWire) {
        this.addItemToList(autoWire, this.autoWire, AutoWireTeamEvent.ADD_AUTO_WIRE);
    }

    public void removeAutoWire(AutoWireModel autoWire) {
        this.removeItemFromList(autoWire, this.autoWire, AutoWireTeamEvent.REMOVE_AUTO_WIRE);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<AutoWireTeamModel> removeConnections() {
        RemoveConnectionsAction<AutoWireTeamModel> _action = new RemoveConnectionsAction<AutoWireTeamModel>(this);
        return _action;
    }
}
