/*
 * 
 */
package net.officefloor.model.woof;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class WoofGovernanceModel extends AbstractModel implements ItemModel<WoofGovernanceModel> {

    public static enum WoofGovernanceEvent {
     CHANGE_WOOF_GOVERNANCE_NAME, CHANGE_GOVERNANCE_SOURCE_CLASS_NAME, ADD_PROPERTY, REMOVE_PROPERTY, ADD_GOVERNANCE_AREA, REMOVE_GOVERNANCE_AREA, ADD_GOVERNANCE_AREA_CONNECTION, REMOVE_GOVERNANCE_AREA_CONNECTION
    }

    /**
     * Default constructor.
     */
    public WoofGovernanceModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public WoofGovernanceModel(
      String woofGovernanceName
    , String governanceSourceClassName
    ) {
        this.woofGovernanceName = woofGovernanceName;
        this.governanceSourceClassName = governanceSourceClassName;
    }

    /**
     * Convenience constructor.
     */
    public WoofGovernanceModel(
      String woofGovernanceName
    , String governanceSourceClassName
    , PropertyModel[] property
    , WoofGovernanceAreaModel[] governanceArea
    , WoofGovernanceToWoofGovernanceAreaModel[] governanceAreaConnection
    ) {
        this.woofGovernanceName = woofGovernanceName;
        this.governanceSourceClassName = governanceSourceClassName;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (governanceArea != null) {
            for (WoofGovernanceAreaModel model : governanceArea) {
                this.governanceArea.add(model);
            }
        }
        if (governanceAreaConnection != null) {
            for (WoofGovernanceToWoofGovernanceAreaModel model : governanceAreaConnection) {
                this.governanceAreaConnection.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public WoofGovernanceModel(
      String woofGovernanceName
    , String governanceSourceClassName
    , PropertyModel[] property
    , WoofGovernanceAreaModel[] governanceArea
    , WoofGovernanceToWoofGovernanceAreaModel[] governanceAreaConnection
    , int x
    , int y
    ) {
        this.woofGovernanceName = woofGovernanceName;
        this.governanceSourceClassName = governanceSourceClassName;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (governanceArea != null) {
            for (WoofGovernanceAreaModel model : governanceArea) {
                this.governanceArea.add(model);
            }
        }
        if (governanceAreaConnection != null) {
            for (WoofGovernanceToWoofGovernanceAreaModel model : governanceAreaConnection) {
                this.governanceAreaConnection.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Woof governance name.
     */
    private String woofGovernanceName;

    public String getWoofGovernanceName() {
        return this.woofGovernanceName;
    }

    public void setWoofGovernanceName(String woofGovernanceName) {
        String oldValue = this.woofGovernanceName;
        this.woofGovernanceName = woofGovernanceName;
        this.changeField(oldValue, this.woofGovernanceName, WoofGovernanceEvent.CHANGE_WOOF_GOVERNANCE_NAME);
    }

    /**
     * Governance source class name.
     */
    private String governanceSourceClassName;

    public String getGovernanceSourceClassName() {
        return this.governanceSourceClassName;
    }

    public void setGovernanceSourceClassName(String governanceSourceClassName) {
        String oldValue = this.governanceSourceClassName;
        this.governanceSourceClassName = governanceSourceClassName;
        this.changeField(oldValue, this.governanceSourceClassName, WoofGovernanceEvent.CHANGE_GOVERNANCE_SOURCE_CLASS_NAME);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, WoofGovernanceEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, WoofGovernanceEvent.REMOVE_PROPERTY);
    }

    /**
     * Governance area.
     */
    private List<WoofGovernanceAreaModel> governanceArea = new LinkedList<WoofGovernanceAreaModel>();

    public List<WoofGovernanceAreaModel> getGovernanceAreas() {
        return this.governanceArea;
    }

    public void addGovernanceArea(WoofGovernanceAreaModel governanceArea) {
        this.addItemToList(governanceArea, this.governanceArea, WoofGovernanceEvent.ADD_GOVERNANCE_AREA);
    }

    public void removeGovernanceArea(WoofGovernanceAreaModel governanceArea) {
        this.removeItemFromList(governanceArea, this.governanceArea, WoofGovernanceEvent.REMOVE_GOVERNANCE_AREA);
    }

    /**
     * Governance area connection.
     */
    private List<WoofGovernanceToWoofGovernanceAreaModel> governanceAreaConnection = new LinkedList<WoofGovernanceToWoofGovernanceAreaModel>();

    public List<WoofGovernanceToWoofGovernanceAreaModel> getGovernanceAreaConnections() {
        return this.governanceAreaConnection;
    }

    public void addGovernanceAreaConnection(WoofGovernanceToWoofGovernanceAreaModel governanceAreaConnection) {
        this.addItemToList(governanceAreaConnection, this.governanceAreaConnection, WoofGovernanceEvent.ADD_GOVERNANCE_AREA_CONNECTION);
    }

    public void removeGovernanceAreaConnection(WoofGovernanceToWoofGovernanceAreaModel governanceAreaConnection) {
        this.removeItemFromList(governanceAreaConnection, this.governanceAreaConnection, WoofGovernanceEvent.REMOVE_GOVERNANCE_AREA_CONNECTION);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<WoofGovernanceModel> removeConnections() {
        RemoveConnectionsAction<WoofGovernanceModel> _action = new RemoveConnectionsAction<WoofGovernanceModel>(this);
        _action.disconnect(this.governanceAreaConnection);
        return _action;
    }
}
