/*
 * OfficeFloor - http://www.officefloor.net
 * Copyright (C) 2005-2013 Daniel Sagenschneider
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.officefloor.plugin.woof;

import net.officefloor.frame.spi.source.SourceProperties;
import net.officefloor.plugin.web.http.application.HttpTemplateAutoWireSection;
import net.officefloor.plugin.web.http.application.WebAutoWireApplication;

/**
 * Context for the {@link WoofTemplateExtensionService}.
 * 
 * @author Daniel Sagenschneider
 */
public interface WoofTemplateExtensionServiceContext extends SourceProperties {

	/**
	 * Obtains the {@link HttpTemplateAutoWireSection} being extended.
	 * 
	 * @return {@link HttpTemplateAutoWireSection} being extended.
	 */
	HttpTemplateAutoWireSection getTemplate();

	/**
	 * Obtains the {@link WebAutoWireApplication} that the
	 * {@link HttpTemplateAutoWireSection} has been added.
	 * 
	 * @return {@link WebAutoWireApplication}.
	 */
	WebAutoWireApplication getWebApplication();

	/**
	 * Obtains the {@link ClassLoader}.
	 * 
	 * @return {@link ClassLoader}.
	 */
	ClassLoader getClassLoader();

}